//
/// file:	wallpapers.hh
/// author:	earthworm
/// date:	Sunday, 12 June 2005
/// about:	manage wallpaper collection with boost filesystem
//

// includes //
//
//#include <someheader>
#include <gconfmm/client.h>
#include <gconfmm/entry.h>
#include <glibmm/ustring.h>
#include "boost/filesystem/operations.hpp"
#include "boost/filesystem/fstream.hpp"

#ifndef _WALLPAPERS_HH_
#define _WALLPAPERS_HH_

namespace fs = boost::filesystem;

// declarations //
//
/// class c_wallpapers manages your wallpapers
class c_wallpapers
{
	// protected class data //
	//
	protected:
		Glib::RefPtr<Gnome::Conf::Client>	m_ref_gconf_client;

		sigc::connection			m_sigc_connection;

	// public class interface //
	//
	public:
		c_wallpapers				();

		virtual
		~c_wallpapers				();

		bool
		set_random				();

		Glib::ustring
		get_current				();

		bool
		delete_curret				();

	// protected class interface //
	//
	protected:
		std::size_t
		count_directory_entries			(fs::path				path_current,
							 std::size_t				& n_file_count);

		void
		get_directory_entry_at_index		(fs::path				path_current,
							 std::size_t				& n_file_index,
							 Glib::ustring				& sz_file);

		void
		regenerate_timeout			(guint					n_cnxn,
							 Gnome::Conf::Entry			gconf_entry);
		

};// end class c_wallpapers

#endif	// _WALLPAPERS_HH_
